=== debian/changelog ===
libpostscriptbarcode (20140312-2) unstable; urgency=low

  * acknowledge package from maintainer
  * debian/control: Use latest Standards-Version

 -- Alexander List <alex@debian.org>  Fri, 06 Jun 2014 17:37:19 +0100

libpostscriptbarcode (20140312-1) unstable; urgency=low

  * New upstream release
  * Added debian/watch
  * Added debian/libpostscriptbarcode.doc-base
  * debian/control: Remove Suggests: postscript-viewer
  * debian/control: Add Build-Depends: ghostscript
  * debian/control: Add Homepage, Vcs-Git and Vcs-Browser
  * debian/control: Use latest Standards-Version
  * debian/control: Updated Description. Closes: #745293.

 -- Terry Burton <tez@terryburton.co.uk>  Tue, 06 May 2014 15:11:15 +0100

libpostscriptbarcode (20080710-1) unstable; urgency=low

  * New upstream release

 -- Terry Burton <tez@terryburton.co.uk>  Mon, 18 Aug 2008 23:32:40 +0100

libpostscriptbarcode (20080406-1) unstable; urgency=low

  * New upstream release

 -- Terry Burton <tez@terryburton.co.uk>  Sat, 14 Jun 2008 14:39:52 +0100

libpostscriptbarcode (20050908-1) unstable; urgency=low

  * Initial Release.

 -- Terry Burton <tez@terryburton.co.uk>  Mon,  8 Sep 2005 00:56:06 +0100
