=== debian/control ===
Source: libpostscriptbarcode
Section: devel
Priority: optional
Maintainer: Terry Burton <tez@terryburton.co.uk>
Uploaders: Alexander List <alex@debian.org>
Build-Depends: debhelper (>= 9), ghostscript
Standards-Version: 3.9.5
Homepage: http://bwipp.terryburton.co.uk
Vcs-Git: git://github.com/bwipp/postscriptbarcode.git
Vcs-Browser: http://github.com/bwipp/postscriptbarcode

Package: libpostscriptbarcode
Architecture: all
Depends: ${misc:Depends}
Description: Barcode Writer in Pure PostScript
 Barcode Writer in Pure Postscript generates all barcode formats entirely
 within PostScript so that the process of converting the input data into the
 printed output can be performed by the printer or RIP itself. This is ideal
 for variable data printing (VDP) and avoids the need to re-implement the
 barcode generation process whenever your language needs change.
