=== debian/changelog ===
libpostscriptbarcode (20200401-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Source-only upload.
  * Bump debhelper compat to 4.5.1.

 -- Boyuan Yang <byang@debian.org>  Fri, 25 Dec 2020 10:21:45 -0500

libpostscriptbarcode (20200401-1) unstable; urgency=low

  * The GS1 QR Code encoder was fixed.

 -- Terry Burton <tez@terryburton.co.uk>  Wed, 01 Apr 2020 21:00:00 +0100

libpostscriptbarcode (20200308-1) unstable; urgency=low

  * New upstream release
  * Fix erroneous use of Vcs-Git and Vcs-Browser
  * Update docs and doc-base to reflect relocated files

 -- Terry Burton <tez@terryburton.co.uk>  Sun, 08 Mar 2020 12:52:55 +0000
