=== debian/control ===
--- 
+++ 
@@ -4,10 +4,8 @@
 Maintainer: Terry Burton <tez@terryburton.co.uk>
 Uploaders: Alexander List <alex@debian.org>
 Build-Depends: debhelper (>= 9), ghostscript
-Standards-Version: 3.9.5
-Homepage: http://bwipp.terryburton.co.uk
-Vcs-Git: git://github.com/bwipp/postscriptbarcode.git
-Vcs-Browser: http://github.com/bwipp/postscriptbarcode
+Standards-Version: 4.5.1
+Homepage: https://bwipp.terryburton.co.uk
 
 Package: libpostscriptbarcode
 Architecture: all
