=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@ --parallel

override_dh_install:
	dh_install --exclude=LICENSE --exclude=CHANGES --exclude=.dirstamp
