=== debian/watch ===
version=3
opts="uversionmangle=s/^(....)-(..)-(.+)/$1$2$3/;s/-/./,filenamemangle=s!.*/(.*)!postscriptbarcode-$1!" https://github.com/bwipp/postscriptbarcode/releases /bwipp/postscriptbarcode/archive/(.+)\.tar\.gz debian uupdate
